#!/usr/bin/perl
# index.cgi
# Display Clam Statistics via a Mysql database

require '../javascript-lib.pl';
require './clamstat-lib.pl';
#FIXME1 add access control #save for very last since this could get complicated and isn't 100% neccesary
#$access{'cs'} #|| &error($text{'cs_ecannot'});

&header($text{'index_title'}, "", undef, 1, 1, 0,
	&help_search_link("clamstat", "man", "doc"));

use warnings;
use diagnostics;
use strict;
use DBI;
use Date::Manip;
use Date::Calc qw/Delta_Days/;
use CGI qw(param header p);
use GD::Graph::bars;
use GD::Graph::pie;

	my $Version = "0.41";
	my $host_count = "10";
	my $virus_count = "1";
	my $log_file = '/var/log/maillog';
	my $user = "clamstat";
	my $pw = "1clamstat2";
	my $database = "clamstat";
	my $serverName = "localhost";
	my $serverPort = "3306";

my $pbh = DBI->connect("DBI:mysql:$database;host=$serverName;port=$serverPort",$user,$pw);
	die "Unable to connect: ".$DBI::errstr."\n" unless (defined $pbh);
	
	our ($ip_addr, $sender);
	my ($data, $email, %ip_addr, $virus, %virus, $Virus, $Sender, $recipient, $Recipient, $message_id, @text_body, @count, @virus_name, $time, $datetime,$hour, %text, $day, @text_body, %server, $server, @server, @countsvr);

print "<table border width=100%>";

	my ($month,$day,$year,$hour,$minute);
	if (param("month")) {
		$month = param("month");
	} else {
		$month = &UnixDate("today",'%m');
	}

	if (param("year")) {
		$year = param("year");
	} else {
		$year = &UnixDate("today",'%Y');
	}

	if (param("day")) {
		$day = param("day");
	} else {
		$day = &UnixDate("today",'%d');
		$day--;
	}

	if (param("hour")) {
		$hour = param("hour");
	} else {
		$hour = "00";
	}

	if (param("minute")) {
		$minute = param("minute");
	} else {
		$minute = "00";
	}

	my ($month2,$day2,$year2,$hour2,$minute2);
	if (param("month2")) {
		$month2 = param("month2");
	} else {
		$month2 = &UnixDate("today",'%m');
	}

	if (param("year2")) {
		$year2 = param("year2");
	} else {
		$year2 = &UnixDate("today",'%Y');
	}
	
	if (param("day2")) {
		$day2 = param("day2");
	} else {
		$day2 = &UnixDate("today",'%d');
	}

	if (param("hour2")) {
		$hour2 = param("hour2");
	} else {
		$hour2 = "23";
	}

	if (param("minute2")) {
		$minute2 = param("minute2");
	} else {
		$minute2 = "59";
	}


	print "<tr><td>";
		print "Date-Time Range\n";
		print "<form action=index.cgi>\n";
		print  "<select name=month size=1>Range \n";
			for (my $j=1; $j<13; $j++) {
				if ($month == $j) {
					print   "<option selected> $j\n";
				} else {
					print   "<option> $j\n";
				}
			}
			print "</option>";
		print "</select>\n";
		print  "<select name=day size=1>\n";
			for (my $k=1; $k<32; $k++) {
				if ($day == $k) {
					print   "<option selected> $k\n";
				} else {
					print   "<option> $k\n";
				}
			}
			print "</option>";
		print "</select>\n";
		print  "<select name=year size=1>\n";
			for (my $l=2004; $l<2030; $l++) {
				if ($year == $l) {
					print   "<option selected> $l\n";
				} else {
					print   "<option> $l\n";
				}
			}
			print "</option>";
		print "</select>\n";
		print  "<select name=hour size=1>\n";
			for (my $m=0; $m<24; $m++) {
				if ($hour == $m) {
					print   "<option selected> $m\n";
				} else {
					print   "<option> $m\n";
				}
			}
		print "</select>\n";
		print  "<select name=minute size=1>\n";
			for (my $n=0; $n<60; $n++) {
				if ($minute == $n) {
					print   "<option selected> $n\n";
				} else {
					print   "<option> $n\n";
				}
			}
		print "</select>\n";
		print "To\n";
		print  "<select name=month2 size=1>\n";
			for (my $o=1; $o<13; $o++) {
				if ($month2 == $o) {
					print   "<option selected> $o\n";
				} else {
					print   "<option> $o\n";
				}
			}
			print "</option>";
		print "</select>\n";
		print  "<select name=day2 size=1>\n";
			for (my $p=1; $p<32; $p++) {
				if ($day2 == $p) {
					print   "<option selected> $p\n";
				} else {
					print   "<option> $p\n";
				}
			}
			print "</option>";
		print "</select>\n";
		print  "<select name=year2 size=1>\n";
			for (my $q=2004; $q<2030; $q++) {
				if ($year2 == $q) {
					print   "<option selected> $q\n";
				} else {
					print   "<option> $q\n";
				}
			}
			print "</option>";
		print "</select>\n";
		print  "<select name=hour2 size=1>\n";
			for (my $r=0; $r<24; $r++) {
				if ($hour2 == $r) {
					print   "<option selected> $r\n";
				} else {
					print   "<option> $r\n";
				}
			}
		print "</select>\n";
		print  "<select name=minute2 size=1>\n";
			for (my $s=0; $s<60; $s++) {
				if ($minute2 == $s) {
					print   "<option selected> $s\n";
				} else {
					print   "<option> $s\n";
				}
			}
		print "</select>\n";
		print "<input type=submit>$text{'index_title'}";
        	print "</form>\n";
	print "</th></td>";

my $c1 = $year . "-" . $month . "-" . $day . " " . $hour . ":" . $minute . ":" . "00";
my $combinedtime1 = UnixDate("$c1",'%Y-%m-%d %H:%M:%S');
my $c2 = $year2 . "-" . $month2 . "-" . $day2 . " " . $hour2 . ":" . $minute2 . ":" . "59";
my $combinedtime2 = UnixDate("$c2",'%Y-%m-%d %H:%M:%S');
	
my $results=$pbh->prepare(q{SELECT * from logs WHERE time BETWEEN ? AND ? }) or
	die "Unable to prepare our query: ".$pbh->errstr."\n";
$results->execute($combinedtime1,$combinedtime2) or die "Unable to execute our query: ".$pbh->errstr."\n";

use Date::Calc qw(Delta_DHMS);
my ($dd, $hours, $minutes, $seconds) = Delta_DHMS( $year, $month, $day, $hour, $minute, 00,
                                                 $year2, $month2, $day2, $hour2, $minute2, 59);
while ($data = $results->fetchrow_arrayref()) {
	$datetime = "$data->[1]";
	$virus = "$data->[2]";
	$ip_addr = "$data->[5]";
	$recipient = "$data->[4]";
	$sender = "$data->[3]";
	$server = "$data->[6]";

	
	if ($dd == "0") {
		#Hourly Chart
		$hour = UnixDate("$datetime",'%d%H');
	        #Count unique virus's seen per hour for plotting
        	$time->{$hour}++;
	} elsif ($dd <= "28") {
		#Days in Month chart
		$day = UnixDate("$datetime",'%m%d');
	        #Count unique virus's seen per hour for plotting
        	$time->{$day}++;
	} elsif ($dd <= "365") {
		#Months in year chart
		$month = UnixDate("$datetime",'%y%m');
	        #Count unique virus's seen per hour for plotting
        	$time->{$month}++;
	} else {
		#Years chart
                $year = UnixDate("$datetime",'%Y');
                #Count unique virus's seen per hour for plotting
                $time->{$year}++;
	}

	#Counts total number of times virus's were sent through a specific server
	$server{$server}++;
	#Counts total number of times a virus was sent
	$ip_addr{$virus}++;
	#Counts total number of virus's sent by IP address
	$virus{$ip_addr}++;
	#Counts total number of unique virus's per IP address
	$email->{$ip_addr}{virus}{$virus}++;
	#Counts total number of unique senders per IP address
		$email->{$ip_addr}{sender}{$sender}++;
	#Counts total number of unique recipients per IP address
		$email->{$ip_addr}{recipient}{$recipient}++;
}

sub hashValueDescendingVirus {
	   $email->{$ip_addr}{virus}{$b} <=> $email->{$ip_addr}{virus}{$a};
}
		
sub hashValueDescendingRecipient {
	   $email->{$ip_addr}{recipient}{$b} <=> $email->{$ip_addr}{recipient}{$a};
}

sub hashValueDescendingSender {
	   $email->{$ip_addr}{sender}{$b} <=> $email->{$ip_addr}{sender}{$a};
}

sub hashValueDescendingNum {
   $ip_addr{$b} <=> $ip_addr{$a};
}

sub hashValueDescendingIp {
   $virus{$b} <=> $virus{$a};
}

sub hashValueDescendingNumSvr {
   $server{$b} <=> $server{$a};
}

foreach $virus (sort hashValueDescendingNum (keys(%ip_addr))) {
	if ($ip_addr{$virus} >=  "$virus_count") {
		push(@text_body, "Count is $ip_addr{$virus} for $virus <br>\n");
		push(@count, $ip_addr{$virus}); 
		push(@virus_name, "$virus $ip_addr{$virus} times"); 
	}
}

print "<tr>";
	&piepng;
if ($dd == "0") {
	&chartpng('hour');
} elsif ($dd <= "7") {
	&chartpng('day');
} elsif ($dd <= "365") {
	&chartpng('month');
} else {
	&chartpng('year');
}
print "</tr>";


print "<tr align=center>";
print "<td valign=top><b>Shows a count of each virus type:</b><br>\n";

for(my $counter=0 ; $counter < @text_body ; $counter++) {
                print "$text_body[$counter]" ;
}


print "</td>";

if ($host_count) {
	print "<td valign=top><b>Shows uniques hosts with a virus count over $host_count:</b><br>\n";
}


for $ip_addr (sort hashValueDescendingIp (keys(%virus))) {
#	add check to only show specific unique hosts -u address, address2
	if ($virus{"$ip_addr"} >= "$host_count") {

		
		print "$ip_addr sent the following virus's a total of $virus{$ip_addr} times:<br>\n";
		
		foreach $Virus (sort hashValueDescendingVirus (keys (%{$email->{$ip_addr}{virus}}) )) {
			print "$Virus $email->{$ip_addr}{virus}{$Virus} times.\n";
		}
		print "<br>";

	}
}

print "</td></tr>\n";
print "</table>\n";


sub chartpng {
	my (@count_by_num, @values);
	my $time_value = shift;
	#Per time_value virus count code phccc
	for my $value (sort keys  %{ $time } ) {
		push @count_by_num, "$time->{$value}";
		$value =~ s/(?:\d\d(\d\d))/$1/g;
		push @values, "$value";
	}


	my @phvccdata = (\@values, \@count_by_num);

	my $phvccgraph = GD::Graph::bars->new(550, 250);
	$phvccgraph->set(
	    x_label     => "Number of " . $time_value . "s",
	    y_label     => 'Number of Virus\'s',
	    title       => "Number of Virus\'s per $time_value",
	) or warn $phvccgraph->error;

	my $phvccimage = $phvccgraph->plot(\@phvccdata) or die $phvccgraph->error;

	open(IMG, ">images/chart.png") or die $!;
	binmode IMG;

	print IMG $phvccimage->png;
	print '<th><img src="images/chart.png" name="Chart" border="1"/><br>';
	&jimg_update("Chart","images/chart.png");
	&serverpng;
}


sub piepng {
#Per virus type count code pvtcc

	# Both the arrays should same number of entries.
	my @pvtccdata = (\@virus_name, \@count);

	my $pvtccgraph = GD::Graph::pie->new(550, 350);
	$pvtccgraph->set(
	    title       => "Virus Breakdown",
	) or warn $pvtccgraph->error;

	my $pvtccimage = $pvtccgraph->plot(\@pvtccdata) or die $pvtccgraph->error;

	open(IMG, '>images/pie.png') or die $!;
	binmode IMG;

	print IMG $pvtccimage->png;
	print '<th><img src="images/pie.png" name="Pie" border="1"/><br></th>';
	&jimg_update("Pie","images/pie.png");
}

sub serverpng {
#Per server virus count code psv

	foreach $server (sort hashValueDescendingNumSvr (keys(%server))) {
                push(@countsvr, $server{$server});
		push(@server, "$server $server{$server} times"); 
	}	

	# Both the arrays should same number of entries.
	my @psvdata = (\@server, \@countsvr);

	my $psvgraph = GD::Graph::pie->new(550, 250);
	$psvgraph->set(
	    title       => "Server Breakdown",
	) or warn $psvgraph->error;

	my $psvimage = $psvgraph->plot(\@psvdata) or die $psvgraph->error;

	open(IMG, '>images/server.png') or die $!;
	binmode IMG;

	print IMG $psvimage->png;
	print '<img src="images/server.png" name="Pie" border="1"/><br></th>';
	&jimg_update("Pie","images/server.png");
}

&footer("/", $text{'index'});

